#!/usr/bin/env python

import sys
import os
import signal
import network_engine
import error_object
import handler
import read_conf

# Instantiate error reporting object, needed by the network engine
errobj = error_object.error_object()

def process_starts():
	pid = os.getpid()
	try:
		runfile = open("/var/run/ctc040.pid", "w")
		runfile.write(`pid`)
		runfile.close()
	except IOError, msg:
		errobj.eprint("Could not open file var/run/ctc040.pid for writing: ", msg)


def process_ends():
	if posixpath.exists("/var/run/ctc040.pid"):
		try:
			os.unlink("/var/run/ctc040.pid")
		except OSError, msg:
			errobj.eprint("/var/run/ctc040.pid: ", msg[1])
	sys.exit(0)


def reconfigure():
	global HCh, confobj, neteng
	print HCh.z_engine
	HCh = handler.handler(confobj.conf, neteng, errobj)
	print HCh.z_engine
	signal.signal(signal.SIGHUP, reconfigure)


if __name__ == '__main__':

	if len(sys.argv) > 1:
		config_file = sys.argv[1]
	else:
		config_file = None
	# Instantiate configuration object
	confobj = read_conf.read_conf(config_file, errobj)
	# Instantiate the network engine
	neteng = network_engine.network_engine(confobj.conf, errobj)
	# Instantiate handler object
	HCh = handler.handler(confobj.conf, neteng, errobj)

	process_starts()

	signal.signal(signal.SIGTERM, process_ends)
	signal.signal(signal.SIGHUP, reconfigure)

	# Go into main loop. The on* functions are defined in handler.py.
	neteng.loop(HCh.onAccept, HCh.onRead, HCh.onClose, HCh.onLoopEnd)

